# Lagom/IBM Integration Examples

[Lagom](https://www.lagomframework.com/) is a framework for developing reactive microservices in Java or Scala. Created by [Lightbend](https://www.lightbend.com/), Lagom is built on the proven [Akka](http://akka.io/) toolkit and [Play Framework](https://playframework.com/), and provides a highly productive, guided path for creating responsive, resilient, elastic, message-driven applications.

This repository contains examples of integrating Lagom services with a variety of technologies provided by IBM, including:

- [WebSphere Liberty](https://developer.ibm.com/wasdev/websphere-liberty/)
- [IBM Bluemix](https://www.ibm.com/cloud-computing/bluemix/)
- [IBM Message Hub](https://developer.ibm.com/messaging/message-hub/)
- [IBM Db2](https://www.ibm.com/analytics/us/en/db2/)
- [IBM Cloud Object Storage](https://www.ibm.com/cloud-computing/bluemix/cloud-object-storage)
- [IBM MQ](http://www.ibm.com/software/products/en/ibm-mq)
- [IBM Db2 Event Store](https://www.ibm.com/us-en/marketplace/db2-event-store)

## Examples

Each example is contained in its own directory within this project, and includes a detailed "README.md" file with instructions for running them:

- [Lagom integration with IBM Message Hub](lagom-message-hub-example/)
- [Lagom integration with IBM Message Hub and WebSphere Liberty](lagom-message-hub-liberty-integration-example/)
- [Lagom integration with IBM Db2 and JPA](lagom-jpa-db2-example/)
- [Lagom integration with IBM Cloud Object Storage](lagom-cloud-object-storage-example/)
- [Lagom integration with IBM MQ](lagom-mq-example-scala/)
- [Lagom integration with IBM Db2 Event Store](lagom-eventstore-example/)


This set of examples will grow over time as new integrations are developed.

## License

Copyright (C) 2017 Lightbend Inc. (https://www.lightbend.com).

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this project except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.
